Subject: bug#63086: 29.0.90; go-ts-mode treesit-query-error during jit-lock

From: Randy Taylor <[email-masked]>
Date: Tue, 02 May 2023 00:29:43 +0000

On Friday, April 28th, 2023 at 06:05, Dmitry Gutov <[email-masked]> wrote:
> On 28/04/2023 04:35, Randy Taylor wrote:
> 
> > Maybe I'm missing something, but doesn't treesit-query-string with an empty string do nothing and always error, since it queries on whatever string you pass in?
> 
> 
> It would return nil, not error (querying an empty buffer). And we should
> be checking for error.
> 
> This is the part that java-ts-mode--string-highlight-helper got right, BTW.

Sorry, I was operating under false assumptions and somehow convinced myself that treesit-query-string with an empty string returning nil meant the query wasn't supported, hence me thinking it achieved nothing. I am no longer under such delusions :).

> 
> go-ts-mode--iota-query-supported-p in your patch relies on the condition
> that the file, at the time the mode is enabled, already contains at
> least one "iota" node.

Good point. I've attached a patch using treesit-query-string with an empty string. It now works properly when iota is missing but inserted later.

> 
> > In that case, wouldn't using treesit-query-capture directly be the best? I don't understand why it's not from reading that thread. If it isn't, then treesit-query-validate is the only option, right?
> 
> 
> treesit-query-validate pops a new buffer interactively in the case of
> failure, so it's not something we should use here.

From b1175773f8a8aa0cacf0b0ecdd6d0d1b3d7ef505 Mon Sep 17 00:00:00 2001
From: Randy Taylor <[email-masked]>
Date: Wed, 26 Apr 2023 11:15:45 -0400
Subject: [PATCH] go-ts-mode: Use iota query only if supported (Bug#63086)

iota query support was added on January 5, 2022.  To support older
versions of the tree-sitter-go grammar (like the latest tagged version,
v0.19.1, which was released on March 3, 2021), check if the query is
supported before trying to use it.

* lisp/progmodes/go-ts-mode.el (go-ts-mode--iota-query-supported-p): New
function.
(go-ts-mode--font-lock-settings): Use it.
---
 lisp/progmodes/go-ts-mode.el | 10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

diff --git a/lisp/progmodes/go-ts-mode.el b/lisp/progmodes/go-ts-mode.el
index 77c97ffac11..f32a2d75775 100644
--- a/lisp/progmodes/go-ts-mode.el
+++ b/lisp/progmodes/go-ts-mode.el
@@ -105,6 +105,12 @@ go-ts-mode--operators
     ">>" "%=" ">>=" "--" "!"  "..."  "&^" "&^=" "~")
   "Go operators for tree-sitter font-locking.")
 
+(defun go-ts-mode--iota-query-supported-p ()
+  "Returns t if the iota query is supported by the current version of
+the tree-sitter-go grammar."
+  (ignore-errors
+    (or (treesit-query-string "" '((iota) @font-lock-constant-face) 'go) t)))
+
 (defvar go-ts-mode--font-lock-settings
   (treesit-font-lock-rules
    :language 'go
@@ -117,7 +123,9 @@ go-ts-mode--font-lock-settings
 
    :language 'go
    :feature 'constant
-   '([(false) (iota) (nil) (true)] @font-lock-constant-face
+   `([(false) (nil) (true)] @font-lock-constant-face
+     ,@(when (go-ts-mode--iota-query-supported-p)
+         '((iota) @font-lock-constant-face))
      (const_declaration
       (const_spec name: (identifier) @font-lock-constant-face)))
 
-- 
2.40.1